@echo off
echo Waiting 30 seconds to allow system to completly boot
@ping 127.0.0.1 -n 30 -w 1000> nul
echo Testing if HD-PVR USB device is working...
c:\windows\system32\devcon status "USB\VID_2040&PID_4900"|find "running"
if errorlevel 1 goto Restart
echo HD-PVR USB Device already working
goto End

:Restart
echo Stopping SageTV Service
net stop sagetv
echo Waiting 20 seconds to allow SageTV to stop...
@ping 127.0.0.1 -n 20 -w 1000> nul
echo Restarting HD-PVR USB Device...
c:\windows\system32\devcon restart "USB\VID_2040&PID_4900"
echo Waiting 20 seconds to allow USB Device to restart...
@ping 127.0.0.1 -n 20 -w 1000> nul
echo Checking if HD-PVR USB Device has recovered...
c:\windows\system32\devcon status "USB\VID_2040&PID_4900"|find "running"
if errorlevel 1 goto RestartHub
echo HD-PVR was reset so starting SageTV Service
net start sagetv
goto End

:RestartHub
echo Restarting Topfield USB ROOT_HUB
c:\windows\system32\devcon restart "@USB\ROOT_HUB20\4&1D269357&0"
REM If you want to find which USB root hub instance belongs to the HD-PVR, with XP SP2 device manager look on the Power tab to determine which one has the HD-PVR device attached, then the Details tab for the Device Instance Id. With other Win releases, you may have to use a combination of devcon findall USB\ROOT_HUB* and trial & error. When specifying a Device Instance Id on the Devcon restart you need to prefix with @ and enclose in double quotes as above. Note that if you plug the HD-PVR into a different USB port I'm sure the Device Instance Id will change.

rem Or you could use the following to restart all root hub instances
rem For USB 2.0 
rem devcon restart USB\ROOT_HUB20 

echo Waiting 20 seconds to allow USB ROOT_HUB to restart...
@ping 127.0.0.1 -n 20 -w 1000> nul

echo starting SageTV Service
net start sagetv
goto End

:End 
pause